Object subclass: #Ataque
	instanceVariableNames: 'puntos'
	classVariableNames: ''
	package: 'Pokemones'!

!Ataque methodsFor: 'as yet unclassified' stamp: 'aa 6/25/2020 17:59'!
afectarPuntos: puntosOriginales
	^ puntosOriginales - puntos.
! !

!Ataque methodsFor: 'as yet unclassified' stamp: 'aa 6/25/2020 19:14'!
puntos
	^ puntos! !


Ataque subclass: #AtaqueAmplificado
	instanceVariableNames: 'ataqueOriginal factor'
	classVariableNames: ''
	package: 'Pokemones'!

!AtaqueAmplificado methodsFor: 'as yet unclassified' stamp: 'aa 6/25/2020 19:06'!
afectarPuntos: puntosOriginales
	^ (puntosOriginales - (factor * (ataqueOriginal puntos))).
! !

!AtaqueAmplificado methodsFor: 'as yet unclassified' stamp: 'aa 6/25/2020 19:16'!
setFactor: unFactor yAtaque: unAtaque
	factor := unFactor.
	ataqueOriginal := unAtaque.
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

AtaqueAmplificado class
	instanceVariableNames: ''!

!AtaqueAmplificado class methodsFor: 'as yet unclassified' stamp: 'aa 6/25/2020 19:13'!
conFactor: unFactor yAtaque: unAtaque
	| ataque |
	ataque := self new.
	ataque setFactor: unFactor yAtaque: unAtaque.
	^ ataque.
! !


Ataque subclass: #Brasas
	instanceVariableNames: ''
	classVariableNames: ''
	package: 'Pokemones'!

!Brasas methodsFor: 'initialization' stamp: 'aa 6/25/2020 17:53'!
initialize
	puntos := 20.! !


Ataque subclass: #ImpacTrueno
	instanceVariableNames: ''
	classVariableNames: ''
	package: 'Pokemones'!

!ImpacTrueno methodsFor: 'initialization' stamp: 'aa 6/25/2020 17:53'!
initialize
	puntos := 10.
! !


Error subclass: #NoTieneAtaqueError
	instanceVariableNames: ''
	classVariableNames: ''
	package: 'Pokemones'!

Object subclass: #Pokemon
	instanceVariableNames: 'tipo'
	classVariableNames: ''
	package: 'Pokemones'!

!Pokemon methodsFor: 'as yet unclassified' stamp: 'aa 6/25/2020 17:45'!
atacarCon: unNombreAtaque a: otroPokemon
	tipo atacarCon: unNombreAtaque a: otroPokemon.
! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'aa 6/25/2020 18:01'!
tipo: unTipo
	tipo := unTipo.




! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'aa 6/25/2020 17:57'!
recibirAtaque: unAtaque
	tipo recibirAtaque: unAtaque.



! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'aa 6/25/2020 18:57'!
evolucionar
	tipo evolucionar: self.
! !


!Pokemon methodsFor: 'accessor' stamp: 'aa 6/25/2020 17:32'!
nombre
	^ tipo nombre.! !

!Pokemon methodsFor: 'accessor' stamp: 'aa 6/25/2020 17:32'!
puntos
	^ tipo puntos.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Pokemon class
	instanceVariableNames: ''!

!Pokemon class methodsFor: 'as yet unclassified' stamp: 'aa 6/25/2020 18:01'!
crearPikachu
	| pokemon |
	pokemon := self new.
	pokemon tipo: (Pikachu new).
	^ pokemon.
	! !

!Pokemon class methodsFor: 'as yet unclassified' stamp: 'aa 6/25/2020 18:02'!
crearCharmander
	| pokemon |
	pokemon := self new.
	pokemon tipo: (Charmander new).
	^ pokemon.
! !


Object subclass: #TipoPokemon
	instanceVariableNames: 'ataques nombre puntos'
	classVariableNames: ''
	package: 'Pokemones'!

!TipoPokemon methodsFor: 'accessing' stamp: 'aa 6/25/2020 17:33'!
nombre
	^ nombre! !

!TipoPokemon methodsFor: 'accessing' stamp: 'aa 6/25/2020 17:59'!
recibirAtaque: unAtaque
	puntos := unAtaque afectarPuntos: puntos.
! !

!TipoPokemon methodsFor: 'accessing' stamp: 'aa 6/25/2020 17:33'!
puntos
	^ puntos! !


!TipoPokemon methodsFor: 'initialization' stamp: 'aa 6/25/2020 18:03'!
initialize
	ataques := Dictionary new.
! !


!TipoPokemon methodsFor: 'as yet unclassified' stamp: 'aa 6/25/2020 18:07'!
atacarCon: unNombreAtaque a: otroPokemon
	| ataque |
	ataque := ataques at: unNombreAtaque ifAbsent: [ NoTieneAtaqueError signal. ].
	otroPokemon recibirAtaque: ataque.

! !

!TipoPokemon methodsFor: 'as yet unclassified' stamp: 'aa 6/25/2020 18:57'!
evolucionar: unPokemon
	self subclassResponsibility.


! !


TipoPokemon subclass: #Charmander
	instanceVariableNames: ''
	classVariableNames: ''
	package: 'Pokemones'!

!Charmander methodsFor: 'initialization' stamp: 'aa 6/25/2020 17:53'!
initialize
	super initialize.
	nombre := 'Charmander'.
	puntos := 100.
	ataques at: 'Brasas' put: (Brasas new).
! !

!Charmander methodsFor: 'initialization' stamp: 'aa 6/25/2020 18:58'!
evolucionar: unPokemon
	unPokemon tipo: (Charmeleon new).
! !


TipoPokemon subclass: #Charmeleon
	instanceVariableNames: ''
	classVariableNames: ''
	package: 'Pokemones'!

!Charmeleon methodsFor: 'as yet unclassified' stamp: 'aa 6/25/2020 19:04'!
initialize 
	super initialize.
	nombre := 'Charmeleon'.
	puntos := 150.
	ataques at: 'Brasas' put: (AtaqueAmplificado conFactor: 1.5 yAtaque: (Brasas new)).
	! !

!Charmeleon methodsFor: 'as yet unclassified' stamp: 'aa 6/25/2020 18:59'!
evolucionar: unPokemon 
	! !


TipoPokemon subclass: #Pikachu
	instanceVariableNames: ''
	classVariableNames: ''
	package: 'Pokemones'!

!Pikachu methodsFor: 'initialization' stamp: 'aa 6/25/2020 18:08'!
initialize
   super initialize.
	nombre := 'Pikachu'.
	puntos := 90.
	ataques at: 'ImpacTrueno' put: (ImpacTrueno new).
! !

!Pikachu methodsFor: 'initialization' stamp: 'aa 6/25/2020 18:58'!
evolucionar: unPokemon 
	
! !
TestCase subclass: #PruebasPokemon
	instanceVariableNames: ''
	classVariableNames: ''
	package: 'Pokemones-Tests'!

!PruebasPokemon methodsFor: 'tests' stamp: 'aa 6/25/2020 18:18'!
test06PikachuNoQuiereEvolucionar

	| pikachu charmander |
	pikachu := Pokemon crearPikachu.
	charmander := Pokemon crearCharmander.
	
	self assert: charmander puntos equals: 100.
	
	pikachu atacarCon: 'ImpacTrueno' a: charmander.
	
	self assert: charmander puntos equals: 90.
	
	pikachu evolucionar.
	self assert: pikachu nombre equals: 'Pikachu'. " se sigue llamando igual "
	
	pikachu atacarCon: 'ImpacTrueno' a: charmander.
	
	self assert: charmander puntos equals: 80. " Siguio atacando con 10 como si nada "! !

!PruebasPokemon methodsFor: 'tests' stamp: 'aa 6/25/2020 18:10'!
test04PCharmanderNoPuedeAtacarConImpacTrueno

	| pikachu charmander |
	pikachu := Pokemon crearPikachu.
	charmander := Pokemon crearCharmander.
	
	self assert: pikachu puntos equals: 90.
	
	self should: [charmander atacarCon: 'ImpacTrueno' a: pikachu] raise: NoTieneAtaqueError.
	
	self assert: pikachu puntos equals: 90. " No hizo ningun ataque y se escribio en el Transcript el error "! !

!PruebasPokemon methodsFor: 'tests' stamp: 'aa 6/25/2020 18:18'!
test05CharmanderEvolucionaACharmeleonYSuPoderAumentaUn50PorCiento

	| pikachu charmander |
	pikachu := Pokemon crearPikachu.
	charmander := Pokemon crearCharmander.
	
	self assert: pikachu puntos equals: 90.
	
	charmander atacarCon: 'Brasas' a: pikachu. " ataca con 20 "
	
	self assert: pikachu puntos equals: 70.
	
	charmander evolucionar.
	self assert: charmander nombre equals: 'Charmeleon'.
	self assert: charmander puntos equals: 150. " De 100 pasa a tener 150 puntos, pero si tenia 50 hubiera pasado a tener 75 "
	
	charmander atacarCon: 'Brasas' a: pikachu. " Ahora ataco con 30 en lugar de 20 "
	
	self assert: pikachu puntos equals: 40.! !

!PruebasPokemon methodsFor: 'tests' stamp: 'aa 6/25/2020 18:09'!
test03PCharmanderAtacaAPikachuConBrasasYLeQuita20PuntosDeVida

	| pikachu charmander |
	pikachu := Pokemon crearPikachu.
	charmander := Pokemon crearCharmander.
	
	self assert: pikachu puntos equals: 90.
	
	charmander atacarCon: 'Brasas' a: pikachu.
	
	self assert: pikachu puntos equals: 70.! !

!PruebasPokemon methodsFor: 'tests' stamp: 'aa 6/25/2020 18:09'!
test02PikachuNoPuedeAtacarConBrasas

	| pikachu charmander |
	pikachu := Pokemon crearPikachu.
	charmander := Pokemon crearCharmander.
	
	self assert: charmander puntos equals: 100.
	
	self should: [pikachu atacarCon: 'Brasas' a: charmander] raise: NoTieneAtaqueError.
	
	self assert: charmander puntos equals: 100. " No hizo ningun ataque y se escribio en el Transcript el error "! !

!PruebasPokemon methodsFor: 'tests' stamp: 'aa 6/25/2020 18:02'!
test01PikachuAtacaACharmanderConImpacTruenoYLeQuita10PuntosDeVida

	| pikachu charmander |
	pikachu := Pokemon crearPikachu.
	charmander := Pokemon crearCharmander.
	
	self assert: charmander puntos equals: 100.
	
	pikachu atacarCon: 'ImpacTrueno' a: charmander.
	
	self assert: charmander puntos equals: 90.! !
