TestCase subclass: #PruebasPokemon
	instanceVariableNames: ''
	classVariableNames: ''
	package: 'Pokemones-Tests'!

!PruebasPokemon methodsFor: 'tests' stamp: 'tomas 6/25/2020 13:27'!
test05CharmanderEvolucionaACharmeleonYSuPoderAumentaUn50PorCiento

	| pikachu charmander |
	pikachu := Pokemon conNombre: 'Pikachu'.
	charmander := Pokemon conNombre: 'Charmander'.
	
	self assert: pikachu puntos equals: 90.
	
	charmander atacarCon: 'Brasas' a: pikachu. " ataca con 20 "
	
	self assert: pikachu puntos equals: 70.
	
	charmander evolucionar.
	self assert: charmander nombre equals: 'Charmeleon'.
	self assert: charmander puntos equals: 150. " De 100 pasa a tener 150 puntos, pero si tenia 50 hubiera pasado a tener 75 "
	
	charmander atacarCon: 'Brasas' a: pikachu. " Ahora ataco con 30 en lugar de 20 "
	
	self assert: pikachu puntos equals: 40.! !

!PruebasPokemon methodsFor: 'tests' stamp: 'tomas 6/25/2020 13:15'!
test04PCharmanderNoPuedeAtacarConImpacTrueno

	| pikachu charmander |
	pikachu := Pokemon conNombre: 'Pikachu'.
	charmander := Pokemon conNombre: 'Charmander'.
	
	self assert: pikachu puntos equals: 90.
	
	charmander atacarCon: 'ImpacTrueno' a: pikachu.
	
	self assert: pikachu puntos equals: 90. " No hizo ningun ataque y se escribio en el Transcript el error "! !

!PruebasPokemon methodsFor: 'tests' stamp: 'tomas 6/25/2020 13:13'!
test02PikachuNoPuedeAtacarConBrasas

	| pikachu charmander |
	pikachu := Pokemon conNombre: 'Pikachu'.
	charmander := Pokemon conNombre: 'Charmander'.
	
	self assert: charmander puntos equals: 100.
	
	pikachu atacarCon: 'Brasas' a: charmander.
	
	self assert: charmander puntos equals: 100. " No hizo ningun ataque y se escribio en el Transcript el error "! !

!PruebasPokemon methodsFor: 'tests' stamp: 'tomas 6/25/2020 13:12'!
test01PikachuAtacaACharmanderConImpacTruenoYLeQuita10PuntosDeVida

	| pikachu charmander |
	pikachu := Pokemon conNombre: 'Pikachu'.
	charmander := Pokemon conNombre: 'Charmander'.
	
	self assert: charmander puntos equals: 100.
	
	pikachu atacarCon: 'ImpacTrueno' a: charmander.
	
	self assert: charmander puntos equals: 90.! !

!PruebasPokemon methodsFor: 'tests' stamp: 'tomas 6/25/2020 13:14'!
test03PCharmanderAtacaAPikachuConBrasasYLeQuita20PuntosDeVida

	| pikachu charmander |
	pikachu := Pokemon conNombre: 'Pikachu'.
	charmander := Pokemon conNombre: 'Charmander'.
	
	self assert: pikachu puntos equals: 90.
	
	charmander atacarCon: 'Brasas' a: pikachu.
	
	self assert: pikachu puntos equals: 70.! !

!PruebasPokemon methodsFor: 'tests' stamp: 'tomas 6/25/2020 13:21'!
test06PikachuNoQuiereEvolucionar

	| pikachu charmander |
	pikachu := Pokemon conNombre: 'Pikachu'.
	charmander := Pokemon conNombre: 'Charmander'.
	
	self assert: charmander puntos equals: 100.
	
	pikachu atacarCon: 'ImpacTrueno' a: charmander.
	
	self assert: charmander puntos equals: 90.
	
	pikachu evolucionar.
	self assert: pikachu nombre equals: 'Pikachu'. " se sigue llamando igual "
	
	pikachu atacarCon: 'ImpacTrueno' a: charmander.
	
	self assert: charmander puntos equals: 80. " Siguio atacando con 10 como si nada "! !
